' Touch.vbs -- Take 1 or more files, and changes the last modified date to the current time.
' John J Schultz -- Public Domain.
'
' Parameters
'   wscript //NOLOGO //B TouchFiles.vbs {file1} [{file3} [...]]
'
' ----------------------------

Option Explicit

Dim aFiles, oShell, oFS, oFolder, oArgs, iCount, bValidParameters, sLine, dTimestamp

set oShell = WScript.CreateObject("WScript.Shell")
sLine = ""
on error resume next
sLine = oShell.RegRead ("HKCR\*\shell\Touch\")
on error goto 0
If sLine = "" Then
	oShell.RegWrite "HKCR\*\shell\Touch\", "Touch", "REG_SZ"
	oShell.RegWrite "HKCR\*\shell\Touch\command\", "wscript.exe """ & WScript.ScriptFullName & """ ""%1""", "REG_SZ"
	MsgBox "You can now touch any file from the context menu in Windows Explorer, by right-clicking on the file and selecting Touch", vbOKonly + vbInformation, "Shell extension installed."
	Set oShell = Nothing
	WScript.Quit (0)
End If
Set oShell = Nothing

Set oArgs = WScript.Arguments
bValidParameters = (oArgs.Count >= 1)
If bValidParameters Then
	For iCount = 0 to oArgs.Count - 1
		If iCount = 0 Then
			ReDim aFiles (iCount)
		Else
			ReDim Preserve aFiles (iCount)
		End If
		aFiles (iCount) = oArgs(iCount)
	Next
End If
Set oArgs = Nothing

If Not bValidParameters Then
	WScript.Echo "Invalid parameters"
	WScript.Quit(0)
End If

dTimeStamp = Now()
Set oFS = CreateObject("Scripting.FileSystemObject")
Set oShell = CreateObject("Shell.Application")
For iCount = 0 To UBound (aFiles, 1)
	If Not oFS.FileExists (aFiles (iCount)) Then
		WScript.Echo "Skipping missing file: " & aFiles (iCount)
	Else
		Set oFolder = oShell.NameSpace(oFS.GetParentFolderName (aFiles (iCount)))
		oFolder.Items.Item(oFS.GetFileName (aFiles (iCount))).ModifyDate = dTimeStamp
		Set oFolder = Nothing
	End If
Next ' File
Set oShell = Nothing
Set oFS = Nothing
